/*
 *
 * d_common.h: a utility definition for a Nomenclature Heuristic Model
 * It may be called also N3, Nomenclature Netowrok Navigator
 * or more simply, MkII.
 *
 * Copyright (c) 1999 Nozomi `James' Ytow
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions, and the following disclaimer,
 *    without modification, immediately at the beginning of the file.
 * 2. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * Where this Software is combined with software released under the terms of 
 * the GNU Public License ("GPL") and the terms of the GPL would require the 
 * combined work to also be released under the terms of the GPL, the terms
 * and conditions of this License will apply in addition to those of the
 * GPL with the exception of any terms or conditions of this License that
 * conflict with, or are expressly prohibited by, the GPL.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	$Id: d_common.h,v 1.2 1999/12/05 19:00:35 nozomi Exp $
 *	$Log: d_common.h,v $
 *	Revision 1.2  1999/12/05 19:00:35  nozomi
 *	*** empty log message ***
 *	
 *	Revision 1.1  1999/03/15 16:42:50  nozomi
 *	gcc 2.7 support macro
 *	
 *	Revision 1.0.0  1999/03/14 02:22:50  nozomi
 *	Initial version, though aka MkII
 *	
 *
 */

#if (!defined(__d_common_h))
#define __d_common_h

#if (__GNUC_MINOR__ < 8)
#include <hash_map.h>
#else
#include <hash_map>
#endif

template <class T> struct Hash: unary_function<T, size_t>{
  size_t operator()(const T &key) const;
};

#include "strdup.h"
#include "strmcmp.h"

#if (__GNUC_MINOR__ < 8)
#include <string.h>
#else
#include <string>
#endif

inline int strcmp(const string &s1, const string &s2) {return strcmp(s1.c_str(), s2.c_str());}
inline int strcmp(const string &s1, const char *s2) {return strcmp(s1.c_str(), s2);}
inline int strcmp(const char *s1, const string &s2) {return strcmp(s1, s2.c_str());}

#endif
